package sun.rmi.transport;

import java.io.IOException;
import java.io.OutputStream;
import java.rmi.server.UID;
import java.util.Vector;
import sun.rmi.server.MarshalOutputStream;

class ConnectionOutputStream extends MarshalOutputStream {
   private boolean resultStream = false;
   private Vector objList;
   private UID ackID = new UID();

   ConnectionOutputStream(OutputStream var1) throws IOException {
      super(var1);
   }

   ConnectionOutputStream(OutputStream var1, boolean var2) throws IOException {
      super(var1);
      this.resultStream = var2;
   }

   void writeID() throws IOException {
      this.ackID.write(this);
   }

   boolean isResultStream() {
      return this.resultStream;
   }

   void saveRef(LiveRef var1) {
      if (this.resultStream) {
         if (this.objList == null) {
            this.objList = new Vector();
         }

         this.objList.addElement(var1);
      }

   }

   void done(Connection var1) {
      if (this.objList != null && !this.objList.isEmpty()) {
         new DGCAckHandler(var1.getChannel(), this.ackID, this.objList);
      }

   }
}
