package sun.rmi.transport;

import java.rmi.dgc.VMID;
import java.rmi.server.LogStream;
import java.util.Enumeration;
import java.util.Vector;

class LeaseInfo {
   VMID vmid;
   long expiration;
   Vector notifyList = new Vector();

   LeaseInfo(VMID var1, long var2) {
      this.vmid = var1;
      this.expiration = System.currentTimeMillis() + var2;
   }

   synchronized void renew(long var1) {
      long var3 = System.currentTimeMillis() + var1;
      if (var3 > this.expiration) {
         this.expiration = var3;
      }

   }

   boolean expired(long var1) {
      if (this.expiration >= var1) {
         return false;
      } else {
         if (DGCImpl.logLevel >= 10) {
            LogStream.log("dgc").println("LeaseInfo.expired: " + this.vmid);
         }

         Enumeration var3 = this.notifyList.elements();

         while(var3.hasMoreElements()) {
            Target var4 = (Target)var3.nextElement();
            var4.vmidDead(this.vmid);
         }

         return true;
      }
   }
}
