package sun.rmi.transport;

import java.io.PrintStream;
import java.rmi.server.LogStream;

public class RMIThread {
   private static ThreadGroup group;

   private RMIThread() {
   }

   public static Thread newThread(Runnable var0, String var1, boolean var2) {
      Thread var3 = new Thread(getThreadGroup(), var0, var1);
      var3.setDaemon(var2);
      return var3;
   }

   private static synchronized ThreadGroup getThreadGroup() {
      if (group == null) {
         ThreadGroup var0;
         ThreadGroup var1;
         for(var0 = Thread.currentThread().getThreadGroup(); (var1 = var0.getParent()) != null; var0 = var1) {
            if (Transport.logLevel >= 20) {
               LogStream.log("transport").println("RMIThread.getThreadGroup: searching up from ThreadGroup: " + var0);
            }
         }

         if (Transport.logLevel >= 20) {
            LogStream.log("transport").println("RMIThread.getThreadGroup: found root ThreadGroup: " + var0);
         }

         try {
            group = new ThreadGroup(var0, "RMI runtime");
         } catch (SecurityException var4) {
            if (Transport.logLevel >= 10) {
               LogStream var3 = LogStream.log("transport");
               ((PrintStream)var3).println("RMIThread.getThreadGroup: security exception: ");
               ((Throwable)var4).printStackTrace(var3);
            }

            group = new ThreadGroup("RMI runtime (applet)");
         }

         if (Transport.logLevel >= 20) {
            LogStream.log("transport").println("RMIThread.getThreadGroup: created RMI ThreadGroup:" + group);
         }
      }

      return group;
   }
}
